/*
* Classic Space Wars
*
* Copyright 1997, The Plastic Factory, All rights reserved
*
* Author: Peter Hirschberg
*
* Written for Microsoft Visual C++ version 5.0
*
* The released version of the CLASSIC SPACE WARS APPLICATION for Windows 95 is
* available from our website at http://www.advancedaerials.com/plastic/index.htm .
* The current version of this SOURCE CODE is also available here.
*
*
*
* License agreement:
*
* This SOURCE CODE may be distributed in unmodified form to any medium.
*
* The SOURCE CODE or the CLASSIC SPACE WARS APPLICATION may not be sold,
* or sold as a part of a commercial package without the express written
* permission of The Plastic Factory (hippies@mnsinc.com).
* This includes shareware.
*
* *** MODIFIED VERSIONS OF THIS SOURCE CODE OR THE SPACE WARS APPLICATION MAY NOT
* *** BE PUBLICLY REDISTRIBUTED WITHOUT AUTHOR APPROVAL!! (hippies@mnsinc.com).
* This includes distributing via a publicly accessible LAN.
* The Plastic Factory retains all rights to this SOURCE CODE,
* and the CLASSIC SPACE WARS APPLICATION.
*
* The Plastic Factory, and Peter Hirschberg will not be held responsible for
* any damage done by the use of this SOURCE CODE,
* or the CLASSIC SPACE WARS APPLICATION.
* It is purely "as-is".
*
* If you find problems with this SOURCE CODE,
* or make any additions/modifications/improvements,
* PLEASE EMAIL THE PLASTIC FACTORY so that they can be propogated to the
* installed base of CLASSIC SPACE WARS users.
* 
* Thank you!
* 
* Peter Hirschberg
* 
* The Plastic Factory
* Email : hippies@mnsinc.com
* Website : http://www.advancedaerials.com/plastic/index.htm
*
*/


#define STRICT

// includes
#include <windows.h>
#include <stdio.h>

#include "resource.h"
#include "object.h"
#include "defines.h"

extern BOOL		Momentum;
extern BOOL		Drag;
extern float	shipRotSpeed;
extern float	shipMaxSpeed;
extern float	shipAccel;
extern float	shipDecel;
extern UINT		edgeMode;
extern UINT		initialFuelAmt;
extern UINT		initialNumMissiles;
extern UINT		roundInitialTime;
extern float	missileLifetime;
extern float	missileSpeed;
extern BOOL		enableGravity;
extern float	SunGravity;
extern unsigned	int	SunVisible;
extern unsigned	int	SunPresent;
extern Object2d	*objectList[];
extern BOOL		gameOver;
extern int		player1SimulMissiles;
extern int		player2SimulMissiles;

/*
 ** HandleInitDialog()
 *
 *Description
 *Handles the task of initializing all text, checkboxes to the current
 *game settings
 */
bool HandleInitDialog(HWND HDlg){
char buf[256];
			// ship options
			CheckDlgButton(HDlg, IDC_CHECK_ENABLEDRAG, (Drag)?BST_CHECKED:BST_UNCHECKED);
			CheckDlgButton(HDlg, IDC_CHECK_ENABLEMOMENTUM, (Momentum)?BST_CHECKED:BST_UNCHECKED);

			sprintf(buf, "%f", shipMaxSpeed);
			SetWindowText(GetDlgItem(HDlg, IDC_EDIT_MAXSPEED), buf);
			sprintf(buf, "%f", shipAccel);
			SetWindowText(GetDlgItem(HDlg, IDC_EDIT_ACCELRATE), buf);
			sprintf(buf, "%f", shipDecel);
			SetWindowText(GetDlgItem(HDlg, IDC_EDIT_DECELRATE), buf);
			sprintf(buf, "%f", shipRotSpeed);
			SetWindowText(GetDlgItem(HDlg, IDC_EDIT_ROTATE), buf);

			// missile options
			sprintf(buf, "%f", missileSpeed);
			SetWindowText(GetDlgItem(HDlg, IDC_EDIT_MISSILESPEED), buf);
			sprintf(buf, "%f", missileLifetime);
			SetWindowText(GetDlgItem(HDlg, IDC_EDIT_MISSILELIFETIME), buf);

			// sun options
			CheckDlgButton(HDlg, IDC_CHECK_SUNVISIBLE, (SunVisible)?BST_CHECKED:BST_UNCHECKED);
			CheckDlgButton(HDlg, IDC_CHECK_SUNPRESENT, (SunPresent)?BST_CHECKED:BST_UNCHECKED);

			// gravity options
			CheckDlgButton(HDlg, IDC_CHECK_ENABLEGRAVITY, (enableGravity)?BST_CHECKED:BST_UNCHECKED);
			CheckDlgButton(HDlg, IDC_CHECK_INVERTEDGRAVITY, (SunGravity>0.0)?BST_CHECKED:BST_UNCHECKED);

			if (SunGravity < 0.0){
				sprintf(buf, "%f", -SunGravity);
			} else {
				sprintf(buf, "%f", SunGravity);
			}
			SetWindowText(GetDlgItem(HDlg, IDC_EDIT_GRAVITYSTRENGTH), buf);

			// game options
			sprintf(buf, "%d", roundInitialTime);
			SetWindowText(GetDlgItem(HDlg, IDC_EDIT_GAMETIME), buf);
			sprintf(buf, "%d", initialFuelAmt);
			SetWindowText(GetDlgItem(HDlg, IDC_EDIT_FUELUNITS), buf);
			sprintf(buf, "%d", initialNumMissiles);
			SetWindowText(GetDlgItem(HDlg, IDC_EDIT_NUMMISSILES), buf);
         sprintf(buf, "%d", player1SimulMissiles);
         SetWindowText(GetDlgItem(HDlg, IDC_EDIT_MAXMISSILES), buf);

			// edge mode options
			CheckDlgButton(HDlg, IDC_RADIO_EDGEWRAP, (edgeMode==EDGEACT_WRAP)?BST_CHECKED:BST_UNCHECKED);
			CheckDlgButton(HDlg, IDC_RADIO_EDGEBOUNCE, (edgeMode==EDGEACT_BOUNCE)?BST_CHECKED:BST_UNCHECKED);

			// dialog box was just created; return TRUE to have
			// Windows set focus to first control:
			return TRUE;

};

/*
 ** SettingsDlgProc()
 *
 *
 *  PARAMETERS:
 *
 *  DESCRIPTION:
 *
 *  RETURNS:
 *
 */
BOOL CALLBACK SettingsDlgProc (HWND HDlg, UINT Msg, UINT WParam, LONG LParam){
float	fVal;
UINT	uVal;
char	*endptr;
char	buf[256];
Object2d	*objP;
UINT		i;


	switch (Msg){
		case WM_INITDIALOG:
			return HandleInitDialog(HDlg);
		case WM_COMMAND:  // user issued a command
			switch (WParam){
				case IDCANCEL:
					// user chose Close command on system menu or
					// pressed Esc; therefore, close the dialog box:
					EndDialog (HDlg, IDCANCEL);
					return TRUE;

				case IDDEFAULT:
               Momentum = MOMENTUM;
					Drag = DRAG;
               shipRotSpeed = SHIPROTSPEED;
					shipMaxSpeed = SHIPMAXSPEED;
               shipAccel = SHIPACCEL;
					shipDecel = SHIPDECEL;
               edgeMode = EDGEMODE;
               initialFuelAmt = INITIALFUELAMOUNT;
               initialNumMissiles = INITIALNUMMISSILES;
					roundInitialTime = ROUNDINITIALTIME;
               missileLifetime = MISSILELIFETIME;
               missileSpeed = MISSILESPEED;
               enableGravity = TRUE;
               SunGravity = SUNGRAVITY;
               SunVisible = SUNVISIBLE;
               SunPresent = SUNPRESENT;
               player1SimulMissiles = PLAYER1SIMULMISSILES;
               player2SimulMissiles = PLAYER2SIMULMISSILES;
               return HandleInitDialog(HDlg);

				case IDOK:
					// ship options
					Drag = IsDlgButtonChecked(HDlg, IDC_CHECK_ENABLEDRAG);
					Momentum = IsDlgButtonChecked(HDlg, IDC_CHECK_ENABLEMOMENTUM);

					GetWindowText(GetDlgItem(HDlg, IDC_EDIT_MAXSPEED), buf, 255);
					fVal = strtod(buf, &endptr);
					if (*endptr == 0){
						shipMaxSpeed = fVal;
					}

					GetWindowText(GetDlgItem(HDlg, IDC_EDIT_ACCELRATE), buf, 255);
					fVal = strtod(buf, &endptr);
					if (*endptr == 0){
						shipAccel = fVal;
					}

					GetWindowText(GetDlgItem(HDlg, IDC_EDIT_DECELRATE), buf, 255);
					fVal = strtod(buf, &endptr);
					if (*endptr == 0){
						shipDecel = fVal;
					}

					GetWindowText(GetDlgItem(HDlg, IDC_EDIT_ROTATE), buf, 255);
					fVal = strtod(buf, &endptr);
					if (*endptr == 0){
						shipRotSpeed = fVal;
					}

					// missile options
					GetWindowText(GetDlgItem(HDlg, IDC_EDIT_MISSILESPEED), buf, 255);
					fVal = strtod(buf, &endptr);
					if (*endptr == 0){
						missileSpeed = fVal;
					}

					GetWindowText(GetDlgItem(HDlg, IDC_EDIT_MISSILELIFETIME), buf, 255);
					fVal = strtod(buf, &endptr);
					if (*endptr == 0){
						missileLifetime = fVal;
					}

					// sun options
					SunVisible = IsDlgButtonChecked(HDlg, IDC_CHECK_SUNVISIBLE);
					SunPresent = IsDlgButtonChecked(HDlg, IDC_CHECK_SUNPRESENT);
					sunA.Visible(SunVisible && SunPresent);
					sunB.Visible(SunVisible && SunPresent);

					// gravity options
					enableGravity = IsDlgButtonChecked(HDlg, IDC_CHECK_ENABLEGRAVITY);

					GetWindowText(GetDlgItem(HDlg, IDC_EDIT_GRAVITYSTRENGTH), buf, 255);
					fVal = strtod(buf, &endptr);
					if (*endptr == 0){
						if (fVal < 0.0){
							fVal = -fVal;
						}
						if (IsDlgButtonChecked(HDlg, IDC_CHECK_INVERTEDGRAVITY)){
							SunGravity = fVal;
						} else {
							SunGravity = -fVal;
						}
					}

					// game options
					GetWindowText(GetDlgItem(HDlg, IDC_EDIT_GAMETIME), buf, 255);
					uVal = strtoul(buf, &endptr, 10);
					if (*endptr == 0){
						roundInitialTime = uVal;
					}

					GetWindowText(GetDlgItem(HDlg, IDC_EDIT_FUELUNITS), buf, 255);
					uVal = strtoul(buf, &endptr, 10);
					if (*endptr == 0){
						initialFuelAmt = uVal;
					}

					GetWindowText(GetDlgItem(HDlg, IDC_EDIT_NUMMISSILES), buf, 255);
					uVal = strtoul(buf, &endptr, 10);
					if (*endptr == 0){
						initialNumMissiles = uVal;
					}

               GetWindowText(GetDlgItem(HDlg, IDC_EDIT_MAXMISSILES), buf ,255);
               uVal = strtoul(buf, &endptr, 10);
               if (*endptr == 0){
               	if(uVal <= MAX_MISSILES){
      	         	player1SimulMissiles = (int)uVal;
         	         player2SimulMissiles = (int)uVal;
                  }
               }

					// edge mode options
					edgeMode = (IsDlgButtonChecked(HDlg, IDC_RADIO_EDGEWRAP))?EDGEACT_WRAP:EDGEACT_BOUNCE;

					// set the edge mode...
					if (!gameOver){
						i=0;
						while( objP = objectList[i]){
							objP->EdgeAction(edgeMode);
							i++;
						}
					}

					EndDialog (HDlg, IDOK);
					return TRUE;

					default:          // have Windows perform default
					return FALSE;  // message processing  
			}

		default:          // have Windows perform default
			return FALSE;  // processing for all other messages
	}
}

